import std.format ;
import Sprite ;

class SPformat
{
  Sprite SP ;
  int    top ;
  int    curx,cury ;
  int    x,y ;
  int    w,h ;
  
  this( Sprite SP, int top, int width, int height ){
    this.SP = SP  ;
    this.top= top ;
    this.w  = width  ;
    this.h  = height ;
  }
  
  void spputc(dchar c){
    if( c == '\n' ){
      cury=cury+1 ;
      curx=0 ;
    }
    SP.set2DSP( c+top, x+(curx*w)+w/2, y+(cury*h)+h/2 ) ;
    curx++ ;
  }

  void print(int x, int y, ...){
    void delegate(dchar) putc = &spputc ;
    this.curx=0;
    this.cury=0;
    this.x=x   ;
    this.y=y   ;
    std.format.doFormat( putc, _arguments, _argptr ) ;
  }
}
