import win32.windows;
import win32.commctrl;
import std.stdio;
import std.string;
import std.utf;
import win32frame.writek;
import win32frame.CommonControl;

class ToolTip {
  static id=0 ;
  HWND hwnd  ;
  HWND phwnd ;
  int  style ;
  TOOLINFO toolinfo ;
  wstring tiptext ;

  this() {
    CommonControl cc = new CommonControl() ;

    style = TTS_ALWAYSTIP ;

    toolinfo.cbSize = TTTOOLINFOW_V1_SIZE ; //TOOLINFO.sizeof ;
    toolinfo.uFlags = TTF_SUBCLASS ;
    toolinfo.uId    = id ;
    toolinfo.hinst  = null ;
    toolinfo.lpszText = cast(wchar*)(toUTF16("" ~ "\0")) ;
    hwnd =null ;
    phwnd=null ;
    id++ ;
  }

  int setText(string tiptext){
    this.tiptext = toUTF16(tiptext ~ "\0") ;
    return(0) ;
  }

  int create(HWND phwnd){
    if( this.hwnd==null ){
      this.hwnd = CreateWindowEx( 0,
				  cast(wchar*)(TOOLTIPS_CLASS),
				  cast(wchar*)(null),
				  style,
				  CW_USEDEFAULT, CW_USEDEFAULT, 
				  CW_USEDEFAULT, CW_USEDEFAULT,
				  phwnd,
				  null, GetModuleHandle(null),
				  null ) ;
      if( this.hwnd==null ){
	return(-1) ;
      }
      toolinfo.hwnd = phwnd ; //GetParent(this.hwnd) ;
    }
    return(0) ;
  }
  
  int setClientRect(){
    if( this.hwnd != null ){
      GetClientRect(toolinfo.hwnd, &toolinfo.rect) ;
      toolinfo.lpszText = cast(wchar*)(this.tiptext) ;
      //      writek("rect=%d,%d,%d,%d id=%d %s\n",
      //	     toolinfo.rect.left,toolinfo.rect.top,toolinfo.rect.right,toolinfo.rect.bottom,
      //	     toolinfo.uId,tiptext) ;
      //      writek("sizeof TOOLINFO = %d\n",toolinfo.cbSize) ;
      SendMessage( this.hwnd, TTM_ADDTOOL, 0, cast(LPARAM)(&toolinfo) ) ;
      return(0) ;
    }
    return(-1) ;
  }
  
  int reNewClientRect(){
    if( this.hwnd != null ){
      GetClientRect(toolinfo.hwnd, &toolinfo.rect) ;
      //      writek("reNew hwnd=%08x  rect=%d,%d,%d,%d id=%d %s\n",
      //	     cast(int)(toolinfo.hwnd),
      //      	     toolinfo.rect.left,toolinfo.rect.top,toolinfo.rect.right,toolinfo.rect.bottom,
      //      	     toolinfo.uId,tiptext) ;
      SendMessage( this.hwnd, TTM_NEWTOOLRECT, 0, cast(LPARAM)(&toolinfo) ) ;
      return(0) ;
    }
    return(-1) ;
  }
  
}
